ICT = ICT or {
	name = "ICTheNextBoss",
	version = "1.2.6",
	running = false,
	spawntime = 900, --Respawn after 15 minutes
	spawntimeMolag = 300, --Respawn after 5 minutes
	fallbackMaxTime = 60,
	libDataShare = nil
}

function ICT.updateTimers()
	for boss, lastSeen in pairs(ICT.fallbackTimes) do
		if ICT.fallbackTimes[boss] > 0 then
			ICT.fallbackTimes[boss] = lastSeen - 1
		end
	end

	local districtString = ""
	local timerString = ""
	local color = ""

	local highestIndex = 6
	if ICT.savedVariables.ccw_cw == true then
		highestIndex = 1
	end
	local highestValue = 0

	for i = 1,6,1 
	do 
		local district = GetString(ICT.datas[i])
		local respawn = ICT.timetable[district]
		local remaining = respawn - os.time()
	
		if remaining > highestValue then
			highestIndex = i
			highestValue = remaining
		end
	end
	

	local districtMolag = GetString(ICT.datas[0])
	local respawnMolag = ICT.timetable[districtMolag]
	local remainingMolag = respawnMolag - os.time()
	
	if remainingMolag > 0 then
		color = "|cFF0000"
		if ICT.savedVariables.chatdebug == true and ICT.timetable[districtMolag] == 0 then
			d(districtMolag .. " is up again.")
		end
	else
		-- Boss is up
		color = "|c00FF00"
		remainingMolag = 0
	end
	
	districtString = districtString .. color .. districtMolag .. "|r\n"
	timerString = timerString .. ICT.secondsToClock(remainingMolag) .. "\n"
	
	if ICT.savedVariables.maptimers == true then
		ICT.ui.districts[districtMolag]:SetText(color .. ICT.secondsToClock(remainingMolag))
	end
	
	local modifier = 1
	local endpoint = 5
	local nextdistrict = ICT.nextcw[highestIndex]
	
	if ICT.savedVariables.ccw_cw == true then
		modifier = -1
		endpoint = -5
		nextdistrict = ICT.nextccw[highestIndex]
	end
	
	for i = nextdistrict+6,nextdistrict+6+endpoint,modifier 
	do 
		local district = GetString(ICT.datas[i])
		local respawn = ICT.timetable[district]
		local remaining = respawn - os.time()
	
		if remaining > 0 then
			color = "|cFF0000"
			if ICT.savedVariables.chatdebug == true and ICT.timetable[district] == 0 then
				d(district .. " is up again.")
			end
		else
			-- Boss is up
			color = "|c00FF00"
			remaining = 0
		end
		
		districtString = districtString .. color .. district .. "|r\n"
		timerString = timerString .. ICT.secondsToClock(remaining) .. "\n"
		
		if ICT.savedVariables.maptimers == true then
			ICT.ui.districts[district]:SetText(color .. ICT.secondsToClock(remaining))
		end
		
		ICT.saveTimers()
	end
	
	if ICT.savedVariables.timetable == true then
		ICTDistricLabel:SetText(districtString)
		ICTTimerLabel:SetText(timerString)
	end
end

function ICT.onMonsterDeath(_, unitTag, isDead)
	local mobName = GetUnitName(unitTag)
	if isDead == true then
		ICT.unitDead(unitName)
	end
end

function ICT.onMonsterReticle(_)
	local unitName = GetUnitNameHighlightedByReticle()
	local isDead = IsUnitDead('reticleover')
	if unitName == nil or unitName == "" then return end
	
	if ICT.savedVariables.chatdebug == true then
		local link = "|H1:icdebug:" .. unitName .. "|h[" .. unitName .. "]|h"
		d(link)
	end
	
	if ICT.fallbackTimes[unitName] == nil or (ICT.timetable[ICT.locations[unitName]] - os.time()) > 0 then return end
	
	if isDead == true then
		if ICT.fallbackTimes[unitName] > 0 then
			ICT.unitDead(unitName)
		end
	else
		ICT.fallbackTimes[unitName] = ICT.fallbackMaxTime
	end
end

function ICT.unitDead(unitName)
	if ICT.locations[unitName] ~= nil then
		local district = ICT.locations[unitName]
		if unitName == GetString(SI_ICTHENEXTBOSS_MOLAG) then 
			ICT.startTimer(district, ICT.spawntimeMolag, true)
		else
			ICT.startTimer(district, ICT.spawntime, true)
		end
		ICT.fallbackTimes[unitName] = 0
		if ICT.savedVariables.chatdebug == true then
			d(unitName .. " died. (in the last " .. ICT.fallbackMaxTime .. "s)")
		end
	end
end

function ICT.saveTimers()
	for i = 0,6,1 
	do 
		local district = GetString(ICT.datas[i])
		local respawn = ICT.timetable[district]
		ICT.savedVariables.saved_timers[district] = respawn
		ICT.savedVariables.saved_timers["data"] = GetCurrentCampaignId()
	end
end

function ICT.restoreTimers()
	if ICT.savedVariables.saved_timers["data"] == GetCurrentCampaignId() then
		for i = 0,6,1 
		do 
			local district = GetString(ICT.datas[i])
			local respawn = ICT.savedVariables.saved_timers[district]
			if respawn then
				if respawn > os.time() then
					ICT.timetable[district] = respawn
				end
			end
		end
	end
end

function ICT.resetTimers()
	if ICT.savedVariables.saved_timers["data"] ~= GetCurrentCampaignId() then
		for i = 0,6,1 
		do 
			local district = GetString(ICT.datas[i])
			ICT.timetable[district] = 0
		end
	end
end

SLASH_COMMANDS["/mark"] = function (districtId)
	if districtId == nil then 
		ZO_Alert(UI_ALERT_CATEGORY_ALERT, nil, "Error")
		return 
	end
	ICT.markDistrict(tonumber(districtId))
end

function ICT.markDistrict(districtId)
	local district = ICT.datas[districtId]
	if district == nil then return end
	ICT.markDead(district)
end

function ICT.getDistrictID(district)
	local districtId = 0
	for index = 0,6,1 do 
		local districtString = ICT.datas[index]
		if district == GetString(districtString) then 
			districtId = index
		end
	end
	return districtId
end

function ICT.markDead(districtString)
	local district = GetString(districtString)
	d(district)
	if ICT.timetable[district] ~= nil then
		if districtString == SI_ICTHENEXTBOSS_CAN then 
			ICT.startTimer(district, ICT.spawntimeMolag, false)
		else
			ICT.startTimer(district, ICT.spawntime, false)
		end
	end
end

function ICT.startTimer(district, spawntime, share)
	if share == true then
		ICT.ShareCode((ICT.getDistrictID(district) * 123456) + 123456)
	end
	ICT.timetable[district] = os.time() + spawntime
end

function ICT.onZoneChange(_, _)
	local zone, x, y, z = GetUnitWorldPosition("player")
	ICT.resetTimers()

	if zone == 584 or zone == 643 then
		if ICT.running == false then
			-- Player joined IC
			ICT.enable()
		else
			-- Player is still in IC
			-- Show Timetable again for some reason
			ICT.showTimetable()
		end
	else
		ICT.disable()
	end
end

function ICT.editSpawnTime()
	if ICT.savedVariables.eventtimers == true then
		ICT.spawntime = 420
	else
		ICT.spawntime = 900
	end
end

function ICT.switchDirection()
	ICT.savedVariables.ccw_cw = not ICT.savedVariables.ccw_cw
end

function ICT.enable()
	EVENT_MANAGER:RegisterForEvent(ICT.name, EVENT_UNIT_DEATH_STATE_CHANGED, ICT.onMonsterDeath)
	EVENT_MANAGER:RegisterForEvent(ICT.name, EVENT_RETICLE_TARGET_CHANGED, ICT.onMonsterReticle)
	EVENT_MANAGER:RegisterForUpdate(ICT.name .. "_loop", 1000, ICT.updateTimers)
	ICTTimeTable:SetWidth(tonumber(GetString(SI_ICTHENEXTBOSS_GUI_WIDTH)))
	ICT.showTimetable()
	ICT.restoreTimers()
	ICT.running = true
end

function ICT.disable()
	local zone, x, y, z = GetUnitWorldPosition("player")
	if zone ~= 181 then	EVENT_MANAGER:UnregisterForUpdate(ICT.name .. "_loop") end -- Cyrodiil escape ;D
	EVENT_MANAGER:UnregisterForEvent(ICT.name, EVENT_UNIT_DEATH_STATE_CHANGED)
	EVENT_MANAGER:UnregisterForEvent(ICT.name, EVENT_RETICLE_TARGET_CHANGED)
	ICTTimeTable:SetHidden(true)
	HUD_SCENE:RemoveFragment(ICT.ui.timetable)
	HUD_UI_SCENE:RemoveFragment(ICT.ui.timetable)
	ICT.running = false
end

function ICT.showTimetable()
	if ICT.savedVariables.timetable == true then
		HUD_SCENE:AddFragment(ICT.ui.timetable)
		HUD_UI_SCENE:AddFragment(ICT.ui.timetable)
		ICTTimeTable:SetHidden(false)
	end
end

function ICT.HandleClickEvent(rawLink, mouseButton, linkText, linkStyle, linkType, data)
	if linkType == "icdebug" then
		CHAT_SYSTEM.textEntry:Open(data)
		return true
	end
end

function ICT.ShareCode(code)
	if code == nil then return end
	if ICT.libDataShare == nil then return end
	ICT.libDataShare:QueueData(tonumber(code), function() end)
end

function ICT.HandleSharedData(_, data)
	local districtID = (data - 123456) / 123456
	ICT.markDistrict(tonumber(districtId))
end

function ICT.OnAddOnLoaded(event, addonName)
	if addonName ~= ICT.name then return end
	
	EVENT_MANAGER:RegisterForEvent(ICT.name, EVENT_PLAYER_ACTIVATED, ICT.onZoneChange)
	
	LINK_HANDLER:RegisterCallback(LINK_HANDLER.LINK_MOUSE_UP_EVENT, ICT.HandleClickEvent)
	LINK_HANDLER:RegisterCallback(LINK_HANDLER.LINK_CLICKED_EVENT, ICT.HandleClickEvent)
	
	ICT.initializeSettingsMenu()
	ICT.restoreUIPosition()
	ICT.onMapOpen()
	ICT.disableMapMouseWheelZoom()
	ICTMapTimers:SetDrawTier(DT_HIGH) --Draw above WorldMap
	
	if LibDataShare ~= nil then
		ICT.libDataShare = LibDataShare:RegisterMap("ICTdataShare", 20, ICT.HandleSharedData)
	end
	
	ICT.editSpawnTime()
	
	ICT.running = false
end

EVENT_MANAGER:RegisterForEvent(ICT.name, EVENT_ADD_ON_LOADED, ICT.OnAddOnLoaded)